/* Change this if the SERVER_NAME environment variable does not report
	the true name of your web server. */
#if 1
#define SERVER_NAME cgiServerName
#endif
#if 0
#define SERVER_NAME "www.boutell.com"
#endif

/* You may need to change this, particularly under Windows;
	it is a reasonable guess as to an acceptable place to
	store a saved environment in order to test that feature. 
	If that feature is not important to you, you needn't
	concern yourself with this. */

#ifdef WIN32
#define SAVED_ENVIRONMENT "c:\\cgicsave.env"
#else
#define SAVED_ENVIRONMENT "/tmp/cgicsave.env"
#endif /* WIN32 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdlib.h>

#include "cgic.h"

void HandleSubmit();
void ShowForm();
void CookieSet();
void Name();
void Address();
void Hungry();
void Temperature();
void Frogs();
void Color();
void Flavors();
void NonExButtons();
void RadioButtons();
void File();
void Entries();
void Cookies();
void LoadEnvironment();
void SaveEnvironment();

enum MyLanguages { MY_LANG_EN, MY_LANG_PL, MY_LANG_COUNT };

static struct lang_pref const sc_my_lang [+MY_LANG_COUNT] = {{ "en_US.ISO-8859-1", 01 }, { "pl_PL.ISO-8859-2", 01 }}; 

static int g_lang; static char const *g_char_set;

char const sc_my_title [+MY_LANG_COUNT] [040] = { "CGIC test", "Pr\363ba biblioteki CGIC" };
char const sc_msg_CONTENT_TYPE [] = "CONTENT-TYPE: TEXT/HTML; CHARSET=";

int cgiMain() {
#ifdef DEBUG
	LoadEnvironment();
#endif /* DEBUG */
	/* Load a previously saved CGI scenario if that button
		has been pressed. */
	if (cgiFormSubmitClicked("loadenvironment") == cgiFormSuccess) {
		LoadEnvironment();
	}
	/* Choose an interface language to use */
{ struct lang_pref_enum a_lpe; static struct lang_pref const *const l_my_lang_rg [02] = { sc_my_lang, sc_my_lang + MY_LANG_COUNT }; 
a_lpe. lpe_next = cgiAcceptLanguage; cgiMatchLanguage (&a_lpe, l_my_lang_rg); 
g_lang = strcmp (a_lpe. lpe_lp. lp_lang, sc_my_lang [+MY_LANG_PL]. lp_lang)? +MY_LANG_EN: +MY_LANG_PL; 
if ((g_char_set = strchr (a_lpe. lpe_lp. lp_lang, '.'))) ++g_char_set; else g_char_set = sc_my_lang [+MY_LANG_EN]. lp_lang + 06; }
	/* Set any new cookie requested. Must be done *before*
		outputting the content type. */
	CookieSet();
	/* Send the content type, letting the browser know this is HTML */
	/* Top of the page */
	fprintf(cgiOut,   "%s%s\n\n"
  "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" >"
"<HTML LANG=%.2s>\n<META HTTP-EQUIV=%.12s %.7s=\"%s%s\" >\n<TITLE>%s</TITLE>\n<H1>%s</H1>\n", 
sc_msg_CONTENT_TYPE, g_char_set, sc_my_lang [+g_lang]. lp_lang, sc_msg_CONTENT_TYPE, sc_msg_CONTENT_TYPE, sc_msg_CONTENT_TYPE + 016, 
g_char_set, sc_my_title [+g_lang], sc_my_title [+g_lang]);
	/* If a submit button has already been clicked, act on the 
		submission of the form. */
	if ((cgiFormSubmitClicked("testcgic") == cgiFormSuccess) ||
		cgiFormSubmitClicked("saveenvironment") == cgiFormSuccess)
	{
		HandleSubmit();
		fprintf(cgiOut, "<hr>\n");
	}
	/* Now show the form */
	ShowForm();
	/* Finish up the page */
	fprintf(cgiOut, "</BODY></HTML>\n");
	return 0;
}

void HandleSubmit()
{
	Name();
	Address();
	Hungry();
	Temperature();
	Frogs();
	Color();
	Flavors();
	NonExButtons();
	RadioButtons();
	File();
	Entries();
	Cookies();
	/* The saveenvironment button, in addition to submitting the form,
		also saves the resulting CGI scenario to disk for later
		replay with the 'load saved environment' button. */
	if (cgiFormSubmitClicked("saveenvironment") == cgiFormSuccess) {
		SaveEnvironment();
	}
}

void Name() {
	char name[81];
	static char sc_msg_name [+MY_LANG_COUNT] [010] = { "Name\0", "Imi\352\0" };
	cgiFormStringNoNewlines("name", name, 81);
	fprintf(cgiOut, "%s: ", sc_msg_name [+g_lang]);
	cgiHtmlEscape(name);
	fprintf(cgiOut, "<BR>\n");
}
	
void Address() {
	char address[241];
	static char sc_msg_address [+MY_LANG_COUNT] [020] = { "Address:\0", "Adres:\0" };
	cgiFormString("address", address, 241);
	fprintf(cgiOut, "%s <PRE>\n", sc_msg_address [+g_lang]);
	cgiHtmlEscape(address);
	fputs("</PRE>\n", cgiOut);
}

void Hungry() {
	static char const 
	sc_msg_hungry [+MY_LANG_COUNT] [020] = { "I am Hungry!\0", "Je\266m g\263odzien!\0" }, 
	sc_msg_not_hungry [+MY_LANG_COUNT] [040] = { "I have had Enough!\0", "Je\266m syt!\0" };
		fprintf(cgiOut, "%s<BR>\n", 
		cgiFormCheckboxSingle("hungry") == cgiFormSuccess? sc_msg_hungry [+g_lang]: sc_msg_not_hungry [+g_lang]);
}
	
void Temperature() {
	double temperature;
	static char const sc_msg_temperature [+MY_LANG_COUNT] [040] = { "My temperature is \0.\0", "Mam temperatur\352 \0.\0" };
	cgiFormDoubleBounded("temperature", &temperature, 80.0, 120.0, 98.6);
	fprintf(cgiOut, "%.1f%s<BR>\n", 
	temperature, sc_msg_temperature [+g_lang] + fprintf (cgiOut, "%s", sc_msg_temperature [+g_lang]) + 01);
}
	
void Frogs() {
	int frogsEaten;
	static char const sc_msg_frogs [+MY_LANG_COUNT] [040] = { "I have eaten \0 frogs.\0", "Zjad\263em \0 \277ab.\0" };
	cgiFormInteger("frogs", &frogsEaten, 0);
	fprintf(cgiOut, "%d%s<BR>\n", 
	frogsEaten, sc_msg_frogs [+g_lang] + fprintf (cgiOut, "%s", sc_msg_frogs [+g_lang]) + 01);
}

	enum MyColors { MY_COLOR_RED, MY_COLOR_GREEN, MY_COLOR_BLUE, MY_COLOR_COUNT }; 
	enum MyFlavors { MY_FLAVOR_PISTACHIO, MY_FLAVOR_WALNUT, MY_FLAVOR_CREME, MY_FLAVOR_COUNT };

char const sc_msg_colors_values [+MY_COLOR_COUNT] [+MY_LANG_COUNT] [020] 
	= {{ "Red\0", "Czerwony\0" }, { "Green\0", "Zielony\0" }, { "Blue\0", "Niebieski\0" }}; 

void Color() {
	int colorChoice; char const *colors [+MY_COLOR_COUNT]; 
	char const sc_msg_color [+MY_LANG_COUNT] [010] = { "I am: \0", "Je\266m: \0" };
	for (; +colorChoice < +MY_COLOR_COUNT; ++colorChoice) colors [+colorChoice] = sc_msg_colors_values [+colorChoice] [+MY_LANG_EN];
	cgiFormSelectSingle("colors", colors, +MY_COLOR_COUNT, &colorChoice, 0);
	fprintf(cgiOut, "%s%s<BR>\n", sc_msg_color [+g_lang], sc_msg_colors_values [+colorChoice] [+g_lang]);
}	 

char const	sc_msg_flavors_values [+MY_FLAVOR_COUNT] [+MY_LANG_COUNT] [020] 
	= {{ "Pistachio", "Pistacjowe" }, { "Walnut", "Orzechowe" }, { "Creme", "\246mietankowe" }};
	 
void Flavors() 
{ 
	static char const sc_msg_hate [+MY_LANG_COUNT] [040] = { "I hate ice cream.\0", "Nienawidz\352 lod\363w.\0" }, 
	sc_msg_favorite [+MY_LANG_COUNT] [0100] = { "My favorite ice cream flavors are:\0", "Oto moje ulubione smaki lod\363w:\0" };
	int flavorChoices[+MY_FLAVOR_COUNT]; char const *flavors [+MY_FLAVOR_COUNT]; 
	int i = 0;
	int result;	
	int invalid; for (; +i < +MY_FLAVOR_COUNT; ++i) flavors [+i] = sc_msg_flavors_values [+i] [+MY_LANG_EN];
	result = cgiFormSelectMultiple("flavors", flavors, +MY_FLAVOR_COUNT, 
		flavorChoices, &invalid);
	if (result == cgiFormNotFound) {
		fprintf(cgiOut, "%s<p>\n", sc_msg_hate [+g_lang]);
	} else {	
		fprintf(cgiOut, "%s\n<ul>\n", sc_msg_favorite [+g_lang]);
		for (i=0; (i < +MY_FLAVOR_COUNT); i++) {
			if (flavorChoices[i]) {
				fprintf(cgiOut, "<li>%s\n", sc_msg_flavors_values [+i] [+g_lang]);
			}
		}
		fputs ("</ul>\n", cgiOut);
	}
}

enum LS { MY_AGES_COUNT = 04, MY_VOTES_COUNT = 04 };

void RadioButtons() 
{ 
	static char const sc_msg_age [+MY_LANG_COUNT] [020] = { "Age of Truck\0", "Wiek ci\352\277ar\363wki\0" }, 
	sc_msg_method [+MY_LANG_COUNT] [010] = { "method\0", "spos\363b\0" };
	int ageChoice = 0;
	char ageText[10]; char x_ages [+MY_AGES_COUNT] [02]; char const *ages [+MY_AGES_COUNT];
	for (; +ageChoice < +MY_AGES_COUNT; ++ageChoice) 
	{ *x_ages [+ageChoice] = +ageChoice + '1'; x_ages [+ageChoice] [01] = 0; ages [+ageChoice] = x_ages [+ageChoice]; }
	/* Approach #1: check for one of several valid responses. 
		Good if there are a short list of possible button values and
		you wish to enumerate them. */
	cgiFormRadio("age", ages, +MY_AGES_COUNT, &ageChoice, 0);

	fprintf(cgiOut, "%s: %s (%s #1)<BR>\n", sc_msg_age [+g_lang],
		ages[ageChoice], sc_msg_method [+g_lang]);

	/* Approach #2: just get the string. Good
		if the information is not critical or if you wish
		to verify it in some other way. Note that if
		the information is numeric, cgiFormInteger,
		cgiFormDouble, and related functions may be
		used instead of cgiFormString. */	
	cgiFormString("age", ageText, 10);

	fprintf(cgiOut, "%s: %s (%s #2)<BR>\n", sc_msg_age [+g_lang], ageText, sc_msg_method [+g_lang]);
}

void NonExButtons() 
{ 
	static char const 
	sc_msg_votes [+MY_LANG_COUNT] [010] = { "Votes\0", "G\263osy\0" }, 
	sc_msg_method [+MY_LANG_COUNT] [010] = { "method\0", "spos\363b\0" }, 
	sc_msg_hate [+MY_LANG_COUNT] [040] = { "I hate them all!\0", "Nienawidz\352 ich wszytkich!\0" }, 
	sc_msg_preferred [+MY_LANG_COUNT] [040] = { "My preferred candidates are:\0", "Oto moi ulubieni kandydaci:\0" };
	int voteChoices[4]; char x_votes [+MY_VOTES_COUNT] [02]; char const *votes [+MY_VOTES_COUNT];
	int i = 0;
	int result;	
	int invalid;

	char **responses; 
	for (; +i < +MY_VOTES_COUNT; ++i) { *x_votes [+i] = 'A' + i; x_votes [+i] [01] = 0; votes [+i] = x_votes [+i]; }

	/* Method #1: check for valid votes. This is a good idea,
		since votes for nonexistent candidates should probably
		be discounted... */
	fprintf(cgiOut, "%s (%s 1):<BR>\n", sc_msg_votes [+g_lang], sc_msg_method [+g_lang]);
	result = cgiFormCheckboxMultiple("vote", votes, +MY_VOTES_COUNT, 
		voteChoices, &invalid);
	if (result == cgiFormNotFound) fprintf(cgiOut, "%s<p>\n", sc_msg_hate [+g_lang]);
	else 
	{ 
		fprintf(cgiOut, "%s\n<ul>\n", sc_msg_preferred [+g_lang]);
		for (i=0; (i < +MY_VOTES_COUNT); i++) {
			if (voteChoices[i]) {
				fprintf(cgiOut, "<li>%s\n", x_votes[i]);
			}
		}
		fputs("</ul>\n", cgiOut);
	}

	/* Method #2: get all the names voted for and trust them.
		This is good if the form will change more often
		than the code and invented responses are not a danger
		or can be checked in some other way. */
	fprintf(cgiOut, "%s (%s 2):<BR>\n", sc_msg_votes [+g_lang], sc_msg_method [+g_lang]);
	result = cgiFormStringMultiple("vote", &responses);
	if (result == cgiFormNotFound) 	
		fprintf(cgiOut, "%s<p>\n", sc_msg_hate [+g_lang]);
	else {
		fprintf(cgiOut, "%s\n<ul>\n", sc_msg_preferred [+g_lang]);
		for (i = 0; responses[i]; ++i) 
			fprintf(cgiOut, "<li>%s\n", responses[i]);
		fputs("</ul>\n", cgiOut);
	}
	/* We must be sure to free the string array or a memory
		leak will occur. Simply calling free() would free
		the array but not the individual strings. The
		function cgiStringArrayFree() does the job completely. */	
	cgiStringArrayFree(responses);
}

void Entries()
{ 
	char const 
	sc_list [+MY_LANG_COUNT] [0100] 
	= { "List of All Submitted Form Field Names:", "Spis wszytkich przes\263anych nazw p\363l formularza:" };
	char **array, **arrayStep;
	fprintf(cgiOut, "%s<p>\n", sc_list [+g_lang]);
	if (cgiFormEntries(&array) != cgiFormSuccess) {
		return;
	}
	arrayStep = array;
	fputs("<ul>\n", cgiOut);
	while (*arrayStep) {
		fputs("<li>", cgiOut);
		cgiHtmlEscape(*arrayStep);
		putc ('\n', cgiOut);
		arrayStep++;
	}
	fputs ("</ul>\n", cgiOut);
	cgiStringArrayFree(array);
}

void Cookies()
{ 
	static char const 
	sc_msg_cookies [+MY_LANG_COUNT] [0200] 
	= { 
		"Cookies Submitted On This Call, With Values (Many Browsers <EM >never</EM > Submit Cookies):\0", 
		"Ciastka wys\263ane w&nbsp;ramach niniejszego wywo\263ania i ich warto\266ci "
		"(wiele przegl\261darek <EM >nigdy</EM > nie wysy\263a ciastek):\0" }, 
		sc_msg_cookie [+MY_LANG_COUNT] [010] = { "Cookie\0", "Ciastko\0" }, 
		sc_msg_value [+MY_LANG_COUNT] [010] = { "Value\0", "Warto\266\346\0" };
	char **array, **arrayStep;
	char cname[1024], cvalue[1024];
	fprintf(cgiOut, "%s<p>\n", sc_msg_cookies [+g_lang]);
	if (cgiCookies(&array) != cgiFormSuccess) {
		return;
	}
	arrayStep = array;
	fprintf(cgiOut, "<table border=1>\n<tr><th>%s<th>%s</tr>\n", sc_msg_cookie [+g_lang], sc_msg_value [+g_lang]);
	while (*arrayStep) {
		char value[1024];
		fputs("<tr><td>", cgiOut);
		cgiHtmlEscape(*arrayStep);
		fputs("<td>", cgiOut);
		cgiCookieString(*arrayStep, value, sizeof(value));
		cgiHtmlEscape(value);
		putc('\n', cgiOut);
		arrayStep++;
	}
	fputs ("</table>\n", cgiOut);
	cgiFormString("cname", cname, sizeof(cname));	
	cgiFormString("cvalue", cvalue, sizeof(cvalue));	
	if (strlen(cname)) {
		static char const 
		sc_msg_new_cookie [+MY_LANG_COUNT] [0100] 
		= { "New Cookie Set On This Call:\0", "Nowe ciastko wys\263ane w&nbsp;niniejszym wywo\263aniu:\0" }, 
		sc_msg_desc [+MY_LANG_COUNT] [0400] 
		= { 
			"If your browser accepts cookies (many do not), "
			"this new cookie should appear in the list above the next time the form is submitted.\0", 
			"Je\266li Wasza przegl\261darka przyjmuje ciastka (niekt\363re przyjmuj\261), "
			"to nowe ciastko powinno pojawi\346 si\352 w&nbsp;powy\277szym spisie przy nast\362pnym wys\263aniu formularza.\0" };
		fprintf(cgiOut, "%s<p>\n", sc_msg_new_cookie [+g_lang]);
		cgiHtmlEscape(cname); putc ('=', cgiOut);
		cgiHtmlEscape(cvalue);
		fprintf(cgiOut, "<p>\n");
		fprintf
		(cgiOut, "%s<p>\n", sc_msg_desc [+g_lang]); 
	}
	cgiStringArrayFree(array);
}
	
void File()
{ 
	static char const 
	sc_msg_filename [+MY_LANG_COUNT] [040] = { "The file name submitted was:\0", "Za\263adowan plik o nazwie:\0" }, 
	sc_msg_filesize [+MY_LANG_COUNT] [040] = { "The file size was: \0 bytes\0", "Rozmiar pliku: \0 bajt\363w\0" }, 
	sc_msg_content_type [+MY_LANG_COUNT] [0100] = { "The alleged content type of the file was:", "Rodzaj pliku by\263 pono\346:" }, 
	sc_msg_untrusted [+MY_LANG_COUNT] [0200] = { "Of course, this is only the claim the browser made when uploading the file.  "
	"Much like the filename, it cannot be trusted.", 
	"Oczywi\266cie jest to tylko pogl\261d wyra\277ony przez przegl\261dark\352 przy \263adowaniu pliku.  "
	"Nie na pewno, podobnie jak nazwa pliku." }, 
	sc_msg_contents [+MY_LANG_COUNT] [0100] = { "The file&rsquo;s contents are shown here:", "Oto zawarto\266\346 pliku:" };
	cgiFilePtr file;
	char name[1024];
	char contentType[1024];
	char buffer[1024];
	int size;
	int got;
	if (cgiFormFileName("file", name, sizeof(name)) != cgiFormSuccess) 
	{ static char const sc_msg_no_file [+MY_LANG_COUNT] [040] = { "No file was uploaded.", "Nie za\263adowan \277aden plik." };
		printf("<p>%s<p>\n", sc_msg_no_file [+g_lang]);
		return;
	} 
	fprintf(cgiOut, "%s ", sc_msg_filename [+g_lang]);
	cgiHtmlEscape(name);
	fputs("<p>\n", cgiOut);
	cgiFormFileSize("file", &size);
	fprintf(cgiOut, "%d%s<p>\n", size, sc_msg_filesize [+g_lang] + fputs (sc_msg_filesize [+g_lang], cgiOut) + 01);
	cgiFormFileContentType("file", contentType, sizeof(contentType));
	fprintf(cgiOut, "%s ", sc_msg_content_type [+g_lang]);
	cgiHtmlEscape(contentType);
	fprintf(cgiOut, "<p>\n%s<p>\n%s<p>\n", sc_msg_untrusted [+g_lang], sc_msg_contents [+g_lang]);
	if (cgiFormFileOpen("file", &file) != cgiFormSuccess) 
	{ static char const sc_msg_noopen [+MY_LANG_COUNT] [040] = { "Could not open the file.", "Nie mogli\266my otworzy\346 pliku." };
		fprintf(cgiOut, "%s<p>\n", sc_msg_noopen [+g_lang]);
		return;
	}
	fputs("<pre>\n", cgiOut);
	while (cgiFormFileRead(file, buffer, sizeof(buffer), &got) ==
		cgiFormSuccess)
	{
		cgiHtmlEscapeData(buffer, got);
	}
	fputs("</pre>\n", cgiOut);
	cgiFormFileClose(file);
}

void ShowForm()
{ 
	static char const 
	sc_msg_name_desc [+MY_LANG_COUNT] [040] = { "Text Field containing Plaintext", "Pole ze zwyk\263\261 tre\266ci\261" }, 
	sc_msg_name_value [+MY_LANG_COUNT] [020] = { "Your Name", "Wasze imi\352" }, 
	sc_msg_address_desc [+MY_LANG_COUNT] [040] = { "Multiple-Line Text Field", "Pole z&nbsp;obszern\261 tre\266ci\261" }, 
	sc_msg_address_value [+MY_LANG_COUNT] [040] = { "Default contents go here. ", "Oto domy\266lna zawarto\266\346. " }, 
	sc_msg_hungry_desc [+MY_LANG_COUNT] [020] = { "Checkbox", "Kratka" }, 
	sc_msg_hungry_label [+MY_LANG_COUNT] [010] = { "Hungry", "G\263odny" }, 
	sc_msg_temperature_desc [+MY_LANG_COUNT] [0100] 
	= { "Text Field containing a Numeric Value", "Pole z&nbsp;tre\266ci\261 o warto\266ci liczbowej" }, 
	sc_msg_temperature_label [+MY_LANG_COUNT] [040] = { "Blood Temperature", "Temperatura krwi" }, 
	sc_msg_frogs_desc [+MY_LANG_COUNT] [0100] 
	= { "Text Field containing an Integer Value", "Pole z&nbsp;tre\266ci\261 o warto\266ci ca\263kowitej" }, 
	sc_msg_frogs_label [+MY_LANG_COUNT] [020] = { "Frogs Eaten", "Zjedzonych \277ab" }, 
	sc_msg_colors_desc [+MY_LANG_COUNT] [040] = { "Single-SELECT", "Wyb\363r pojedy\361czy\0" }, 
	sc_msg_flavors_desc [+MY_LANG_COUNT] [020] = { "Multiple-SELECT", "Wyb\363r mnogi" }, 
	sc_msg_age_desc [+MY_LANG_COUNT] [0200] 
	= { "Exclusive Radio Button Group: Age of Truck in Years", 
	"Wy\263\261czna grupa prze\263\261cznik\363w kana\263owych: Wiek ci\352\277ar\363wki w&nbsp;latach" }, 
	sc_msg_vote_desc [+MY_LANG_COUNT] [0200] 
	= { "Nonexclusive Checkbox Group: Voting for Zero through Four Candidates", 
	"Niewy\263\261czna grupa kratek: G\263osowanie na zero do czterech kandydat\363w" }, 
	sc_msg_file_desc [+MY_LANG_COUNT] [020] = { "File Upload", "Za\263adunek pliku" }, 
	sc_msg_file_label [+MY_LANG_COUNT] [040] = { "Select A Local File", "Wybierz plik miejscowy" }, 
	sc_msg_cookie_desc [+MY_LANG_COUNT] [040] = { "Set a Cookie", "Zam\363wienie ciastka" }, 
	sc_msg_cookie_name [+MY_LANG_COUNT] [020] = { "Cookie Name", "Nazwa ciastka" }, 
	sc_msg_cookie_value [+MY_LANG_COUNT] [040] = { "Cookie Value", "Zawarto\266\346 ciastka" }, 
	sc_msg_save_desc [+MY_LANG_COUNT] [040] = { "Save the CGI Environment", "Przechowanie \266rodowiska CGI" }, 
	sc_msg_save_label [+MY_LANG_COUNT] [0400] 
	= { "Pressing this button will submit the form, then save the <ABBR >CGI</ABBR > environment" 
	" so that it can be replayed later by calling cgiReadEnvironment (in a debugger, for instance).", 
	"Naci\266ni\352cie tego przycisku spowoduje wys\263anie formularza, "
	"a nast\352pnie zapisanie \266rodowiska <ABBR>CGI</ABBR > w&nbsp;postaci umo\277liwiaj\261cej p\363\274niejsze jego odtworzenie"
	" poprzez wywo\263anie funkcji cgiReadEnvironment (na przyk\263ad w&nbsp;ramach wiwisekcji)." }, 
	sc_msg_save_button [+MY_LANG_COUNT] [040] = { "Save Environment", "Zapisz \266rodowisko" }; int an_ix = 0;
	fprintf(cgiOut, "<!-- 2.0: multipart/form-data is required for file uploads. -->"
	 "<form method=POST enctype=\"multipart/form-data\" action=\"#\">\n"
	 "<p>\n%s\n<p>\n<input type=text name=name title=\"%s\"\n"
	 "<p>\n%s\n<p>\n<textarea NAME=address ROWS=4 COLS=40>\n%s\n</textarea>\n"
	 "<p>\n%s\n<p>\n<input type=checkbox name=hungry checked title=\"%s?\">\n"
	 "<p>\n%s\n<p>\n<input type=text name=temperature value=\"%.1f\" title=\"%s (%.1f&ndash;%.1f)\">\n"
	 "<p>\n%s\n<p>\n<input type=text name=frogs value=\"%d\" title=\"%s\">\n<p>\n%s\n<br>\n<select name=colors>\n", 
	  sc_msg_name_desc [+g_lang], sc_msg_name_value [+g_lang], sc_msg_address_desc [+g_lang], sc_msg_address_value [+g_lang], 
	  sc_msg_hungry_desc [+g_lang], sc_msg_hungry_label [+g_lang], sc_msg_temperature_desc [+g_lang], 98.6, 
	  sc_msg_temperature_label [+g_lang], 80.0, 120.0, sc_msg_frogs_desc [+g_lang], 01, sc_msg_frogs_label [+g_lang], 
	  sc_msg_colors_desc [+g_lang]); 
	  for (an_ix = 0; +an_ix < +MY_COLOR_COUNT; ++an_ix) 
	  fprintf 
	  (cgiOut, "<option value=\"%s\">%s\n", 
	  sc_msg_colors_values [+an_ix] [+MY_LANG_EN], sc_msg_colors_values [+an_ix] [+g_lang]);
	  fprintf (cgiOut, 
	  "</select>\n<br>\n%s\n<br>\n<select name=flavors multiple>\n", sc_msg_flavors_desc [+g_lang]); 
	  for (an_ix = 0; +an_ix < +MY_FLAVOR_COUNT; ++an_ix)
	  fprintf (cgiOut, "<option value=\"%s\">%s\n", 
	  sc_msg_flavors_values [+an_ix] [+MY_LANG_EN], sc_msg_flavors_values [+an_ix] [+g_lang]); 
	  fprintf (cgiOut, "</select>\n<p>%s\n", sc_msg_age_desc [+g_lang]); 
	  for (an_ix = '1'; +an_ix <= '4'; ++an_ix) 
	  fprintf (cgiOut, 
	  "<input type=radio name=age value=\"%c\" %s>%d\n", an_ix, +an_ix == '3'? "checked": "", +an_ix - '0');
	  fprintf (cgiOut, "<p>%s\n", sc_msg_vote_desc [+g_lang]); 
	  for (an_ix = 'A'; an_ix <= 'D'; ++an_ix) fprintf (cgiOut, "<input type=checkbox name=vote value=\"%c\">%c\n", +an_ix, +an_ix);
	  fprintf (cgiOut, "<p>%s:\n<input type=file name=file title=\"%s\">\n<p>\n<p>%s<p>\n"
	  "<input type=text name=cname title=\"%s\"> = <input type=text name=cvalue title=\"%s\"><p>\n"
	  "<input type=submit name=testcgic>\n<input type=reset>\n<p>%s<p>\n%s<p>\n"
	  "<input type=submit name=saveenvironment value=\"%s\">\n"
	  "</form>\n", 
	  sc_msg_file_desc [+g_lang], sc_msg_file_label [+g_lang], 
	  sc_msg_cookie_desc [+g_lang], sc_msg_cookie_name [+g_lang], sc_msg_cookie_value [+g_lang], 
	  sc_msg_save_desc [+g_lang], sc_msg_save_label [+g_lang], sc_msg_save_button [+g_lang]);
}

void CookieSet()
{
	char cname[1024];
	char cvalue[1024];
	/* Must set cookies BEFORE calling cgiHeaderContentType */
	cgiFormString("cname", cname, sizeof(cname));	
	cgiFormString("cvalue", cvalue, sizeof(cvalue));	
	if (strlen(cname)) {
		/* Cookie lives for one day (or until browser chooses
			to get rid of it, which may be immediately),
			and applies only to this script on this site. */	
		cgiHeaderCookieSetString(cname, cvalue,
			86400, cgiScriptName, SERVER_NAME);
	}
}

void LoadEnvironment()
{
	if (cgiReadEnvironment(SAVED_ENVIRONMENT) != 
		cgiEnvironmentSuccess) 
	{
		cgiHeaderContentType("text/html");
		fprintf(cgiOut, "<head>Error</head>\n");
		fprintf(cgiOut, "<body><h1>Error</h1>\n");
		fprintf(cgiOut, "cgiReadEnvironment failed. Most "
			"likely you have not saved an environment "
			"yet.\n");
		exit(0);
	}
	/* OK, return now and show the results of the saved environment */
}

void SaveEnvironment()
{
	if (cgiWriteEnvironment(SAVED_ENVIRONMENT) != 
		cgiEnvironmentSuccess) 
	{
		fprintf(cgiOut, "<p>cgiWriteEnvironment failed. Most "
			"likely %s is not a valid path or is not "
			"writable by the user that the CGI program "
			"is running as.<p>\n", SAVED_ENVIRONMENT);
	} else {
		fprintf(cgiOut, "<p>Environment saved. Click this button "
			"to restore it, playing back exactly the same "
			"scenario: "
			"<form method=POST action=\"");
		cgiValueEscape(cgiScriptName);
		fprintf(cgiOut, "\">" 
			"<input type=\"submit\" "
			"value=\"Load Environment\" "
			"name=\"loadenvironment\"></form><p>\n");
	}
}

